#Region "License"
' MLib - Miscellaneous library
' Copyright (C) 2006  TFG (tfg@panicus.org)

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#End Region

#Region "Comments/Credits"
' (1) Bit Shifting routines (slightly adapted)
'     Donald Moore (MindRape) moore@futureone.com
#End Region

Public Class Common
    Public Enum vkpModes
        ReadOnlyBox = 0
    End Enum

    Public Shared Sub inc(ByRef lValue As Integer, Optional ByVal count As Integer = 1)
        lValue = lValue + count
    End Sub

    Public Shared Sub dec(ByRef lValue As Integer, Optional ByVal count As Integer = 1)
        lValue = lValue - count
    End Sub

    Public Shared Function ExtractFilename(ByVal filename As String) As String
        Return Microsoft.VisualBasic.Right(filename, filename.Length - filename.LastIndexOf("\") - 1)
    End Function

    Public Shared Function shl(ByVal lValue As Long, ByVal lNumberOfBitsToShift As Long) As Long
        shl = lValue * (2 ^ lNumberOfBitsToShift)
    End Function

    Public Shared Function shr(ByVal lValue As Long, ByVal lNumberOfBitsToShift As Long) As Long
        shr = lValue \ (2 ^ lNumberOfBitsToShift)
    End Function

    Public Shared Function ValidateKeyPress(ByVal KeyPress As Char, Optional ByVal vkpMode As vkpModes = vkpModes.ReadOnlyBox) As Boolean
        Select Case vkpMode
            Case vkpModes.ReadOnlyBox : Return True
        End Select
    End Function

    Public Shared Function ValidateKeyDown(ByVal KeyCode As System.Windows.Forms.Keys) As Boolean
        Return (KeyCode = Keys.Delete)
    End Function
End Class
