#Region "License"
' SNES.Misc - Miscellaneous routines for various SNES-related purposes
' Copyright (C) 2006  TFG (tfg@panicus.org)

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#End Region

#Region "Comments/Credits"
' (1) SNES -> Rom conversion routines courtesy
'     of MathOnNapkins.
#End Region

Imports MLib.Common

Public Class Misc
    Public Shared Function LoRomToFileOffset(ByVal SNESAdd As Long, Optional ByVal includeHeader As Boolean = False) As Long
        If includeHeader Then
            Return ((SNESAdd And &H7FFF) Or (shr((SNESAdd And &HFF0000), 1) And &HFFFFFF)) + &H200
        Else
            Return ((SNESAdd And &H7FFF) Or (shr((SNESAdd And &HFF0000), 1) And &HFFFFFF))
        End If
    End Function

    Public Shared Function HiRomToFileOffset(ByVal SNESAdd As Long, Optional ByVal includeHeader As Boolean = False) As Long
        If includeHeader Then
            Return ((SNESAdd - &HC00000) + &H200) And &HFFFFFF
        Else
            Return ((SNESAdd - &HC00000)) And &HFFFFFF
        End If
    End Function

    Public Shared Function FileOffsetToLoRom(ByVal fileOffset As Long, Optional ByVal includeHeader As Boolean = False) As Long
        If includeHeader Then
            Return ((fileOffset And &H7FFF) Or (shl((fileOffset And &HFF8000), 1) Or &H8000)) + &H200
        Else
            Return ((fileOffset And &H7FFF) Or (shl((fileOffset And &HFF8000), 1) Or &H8000))
        End If
    End Function

    Public Shared Function FileOffsetToHiRom(ByVal fileOffset As Long, Optional ByVal includeHeader As Boolean = False) As Long
        If includeHeader Then
            Return (fileOffset + &HC00000) + &H200
        Else
            Return (fileOffset + &HC00000)
        End If
    End Function
End Class

